/*
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation.  All Rights
 * Reserved.
 *
 * Contributor(s):
 *   EVM-Group <evm@s3.uni-essen.de>
 */


// **************************************************************************
// ************************* EVM-XUL Functions ******************************
// **************************************************************************
// +++ EVM window functions +++
// * for English description please read functions' prologues
//
// Kai Henning:
// evmNewMessage(event)										--> ffnet neues Mailfenster
// evmCreateMailListFromDBEntries(to_cc_bcc,msgid,separator,realnameonly,newDBquery)
//															--> schreibt alle to/cc/bcc-
// 																Eintrge in einen String
// evmCreateMailArrayFromDBEntries(to_cc_bcc,msgid)			--> schreibt alle to/cc/bcc-
//																Eintrge in ein Array
// evmGetReparsedBody(msgid)								--> holt den entspr Body aus DB
// evmMsgForwardAsInline(event)								--> leitet Mail weiter
// evmMsgReply(uno)											--> antwortet auf Mail
// evmInitializeCategorytrees(treename,array)				--> adds DB-categories in tree
// evmInitializeSearchtrees(treename,array)					--> baut Baum aus DB-Searchs auf
// evmMailviewfolderpaneboxselected()						--> deletes the threadpane and
//																calls function to fill it
// evmIsInteger(pruef)										--> prft ob Integer
// evmWriteMozillaAccountsToDB()							--> fllt die account-Tabelle
// evmUpdateCategorytrees()									--> baut category-trees neu auf
// evmInitializeThreadpaneConcerningCategory(category)		--> baut threadpane neu auf
// evmInitializeEVM()										--> initialisiert Buttons etc
// evmDisableMailButtons(b)									--> schaltet Mailbuttons an
//																und aus
// evmDeleteMarkedMessage()									--> lscht eine Nachricht aus
//																Threadpane und DB
// evmAppendChosenCategories()								--> fllt den rechten Category-
//																Baum
// evmInsertIntoChosenCategories()							--> schreibt in die header_category
//																Tabelle
// evmDeleteChosenCategories()								--> lscht aus Category-Baum
// evmCloseEVMWithoutChosenCategories()						--> schliet nach Abfrage das
//																EVM-Fenster
// evmInitializeAddressbooktree()							--> schreibt vorhandene Adre-
//																daten aus DB in Tree
// evmChangeRealnameOfMailaddress()							--> Umbenennen des Realnames
// evmDeleteAddressFromMailaddressTable()					--> Lschen einer Eintragung
// evmCheckNocategoryMails()								--> Hinweis auf 'Waisen' beim
//																Schlieen des EVM-Fensters
// evmActivateAddressButtons()								--> aktiviert ggf Buttons (Adrebuch)
// evmOnCategorytabpaneselected()							--> linker Baum ausgewhlt
// evmOnChosenCategorytabpaneselected()						--> rechter Baum ausgewhlt
// evmRenameCurrentCategory()								--> Umbennen von Kategorien
// evmDeleteCurrentCategory()								--> Lschen von Kategorien
// evmCreateNewSubcategory()								--> neue Unterkategorie erzeugen
// evmCreateNewCategory()									--> nur Umleitung auf zweiten
//																Tabpanel
// evmEmptyCache()											--> lscht temporr angelegte Dateien
// evmLeastVisits(actualBody)								--> entfernt die Mail(s) mit den wenigsten
//																'Hits' im Threadpane (um Cachegre zu
//																verringern)
// evmRemoveMostUnimportantBodyEntries(wegdamit)			--> entfernt alle Spuren der Mail, die von
//																von obiger Funktion zurckgeliefert wird
// evmDeleteUnimportantBodiesExceptActual(actualBodyFilename,actualBodySize)	--> lscht temp.Datei
//																					(nicht eigene)
// evmRemoveAllCachedBodiesExceptCurrent(current)			--> lscht alle temp.Dateien auer eigenen
// evmLoadBody(diff)										--> ldt Body in Messagepane
// evmRemoveToofastclicksRests()							--> 'clean-up'-Funktion fr temp.Dateien
// evmInitializePreferences()								--> initialisiert Preferences-Tabpanel
// evmCheckAndUpdateEVMCacheSize()							--> kontrolliert den Cache
// evmGetAttachmentMailDir()								--> liefert Pfad, der fr Attachmentspeicherung
//																vorgesehen ist
// evmThreadPaneKeyPress(event)								--> event-handler fr threadpane
// evmEmptytrash()											--> lscht Ordner evmTrash
// evmStuffInTrash()										--> liefert boolschen Wert ob Eintrge in evmTrash
// evmOpenEVMMessageInMozillaWindow()						--> ffnet Mail in Mozilla-eigenem Fenster
// evmRemoveTempFileInLocalFolders()						--> lscht temporre Dateien aus LocalFolders
// evmCreateFakeMailboxFromDBEntries(messageID)				--> schreibt DB-Eintrge auf Festplatte, so da
//																eine Art 'virtuelle Mailbox' entsteht
// evmDeleteNotNeededAddressesFromMailaddressTable()		--> entfernt alle Mailaddressen, die nicht mehr mit
//																gespeicherten Mails in Beziehung stehen
// evmCategoryKeyPress(event)								--> event-Handler
// evmAddressKeyPress(event)								--> event-Handler
// evmMailviewCatKeyPress(event)							--> event-Handler
// evmPathSep()												--> liefert \ bzw / (je nach Betriebssystem) bzw
//																macht Eintrag selbst falls nicht vorhanden
//
// **************************************************************************
// Version: 18.02.2004 (Kai Henning, Andr Grothues)
// **************************************************************************

  var serverArrays = {};
  var gEvmCreateMailListFromDBEntriesVar = 0;
  var gAddressArray = [];
  var gHasMailsWithNoCategory = false;
  var gCategorytabboxLeftPaneActive = true;
  var createdFilesInLocalFolder = [];
  var globalorderbycolumn = 1;
  var globalordertype = 1;

  var bodycache = {};
  var bodycount = 0; 		// num of mails in cache files
  var sizemax = 10000;		// max size of cache files (in bytes)
  var sizecount = 0;		// counts up the space we have taken
  var visitcount = {};	// counts visits ('importance') of body
  var onetoobigexception = false;	// if a single body is bigger than the max, we will make an exception


  // *************************************************************************
  // function:		evmNewMessage(event)
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // opens a new message window using the mozilla default account; it also
  // sets fonts and a justified body
  function evmNewMessage(event)
  {
    var composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
    var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(Components.interfaces.nsIMsgComposeParams);
    composeFields.body = "<div align='justify'><font face='Arial' size='2' color='#000001'>Hallo&nbsp;";
    params.composeFields = composeFields;
    var msgComposeService = Components.classes['@mozilla.org/messengercompose;1'].getService();
    msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
    msgComposeService.OpenComposeWindowWithParams(null,params);
  }


  // *************************************************************************
  // function:		evmCreateMailListFromDBEntries(to_cc_bcc,msgid,separator,realnameonly,newDBquery)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // gets DB entries for the message identified by the message-ID (msgid) and
  // creates a string of original recipients (separated by comma) which can be
  // found in either the to-, the cc-, or the bcc-fields
  // in case of error the string "evmError" is returned; if no entry is
  // available, "evmEmpty" is returned
  // we can also specify the separator: either the normal "<" or its HTML version
  // "&lt;"
  // 'realnameonly' says whether we need realnames only
  // 'newDBquery' says whether we need a new DB query or whether we can use the
  // values we still have in the gEvmCreateMailListFromDBEntriesVar
  function evmCreateMailListFromDBEntries(to_cc_bcc,msgid,separator,realnameonly,newDBquery)
  {
    try
    {
      var q = "SELECT mailaddress.realname, mailaddress.address, mailadrtype FROM mailaddress JOIN header_mailaddress ON (mailaddress.id = header_mailaddress.mailaddressid AND msgid = '" + msgid + "')";
      try
      {
        if(newDBquery == true)
        {
          gEvmCreateMailListFromDBEntriesVar = 0;
          var r = connection.executeQuery(q);
          gEvmCreateMailListFromDBEntriesVar = r;
        }
        else
        {
          r = gEvmCreateMailListFromDBEntriesVar;
        }
      }
      catch (ex)
      {
        alert("evmCreateMailListFromDBEntries: " + connection.errorMessage);
        return "evmError";
      }
      if (r.rowCount > 0)
      {
        var ergebnisstring = "";
        var e = r.enumerate();
        e.first();
	    for(var i = 1; i <= r.rowCount; i++)
	    {
		  if(e.getVariant(2) == to_cc_bcc)
		  {
		    if(ergebnisstring != "") ergebnisstring = ergebnisstring + ", ";
		    if(realnameonly == true) ergebnisstring = ergebnisstring + e.getVariant(0);
	        else
	        {
	          if(e.getVariant(0) != e.getVariant(1)) ergebnisstring = ergebnisstring + e.getVariant(0) + " " + separator + e.getVariant(1) + ">";
	          else ergebnisstring = ergebnisstring + separator + e.getVariant(1) + ">";
	        }
	      }
	      if (i < r.rowCount)
	      {
	        e.next();
	      }
	    }
	    if(ergebnisstring == "") ergebnisstring = "evmEmpty";
	    return ergebnisstring;
      }
      else return "evmEmpty";
    }
    catch(ex)
    {
      // alert("EVM Error in function evmCreateMailListFromDBEntries: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmCreateMailArrayFromDBEntries(to_cc_bcc,msgid)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // gets DB entries for the message identified by the message-ID (msgid) and
  // creates an array of original recipients which can be found in either the
  // to-, the cc-, or the bcc-fields; arrays are necessary for composeFields
  // when you want to fill the .to, the .cc, or the .bcc with entries from the
  // DB.
  // in case of error the string "evmError" is returned; if no entry is
  // available, an empty array is returned
  function evmCreateMailArrayFromDBEntries(to_cc_bcc,msgid)
  {
    try
    {
      var q = "SELECT mailaddress.realname, mailaddress.address FROM mailaddress JOIN header_mailaddress ON (mailaddress.id = header_mailaddress.mailaddressid AND msgid = '" + msgid + "' AND mailadrtype = '" + to_cc_bcc + "')";
      try
      {
        var r = connection.executeQuery(q);
      }
      catch (ex)
      {
        alert("evmCreateMailArrayFromDBEntries: " + connection.errorMessage);
        return "evmError";
      }
      var ergebnisarray = [];
      if (r.rowCount > 0)
      {
        var ergebnisstring = "";
        var e = r.enumerate();
        e.first();
	    for(var i = 1; i <= r.rowCount; i++)
	    {
	      ergebnisstring = "";
	      if(e.getVariant(0) != e.getVariant(1)) ergebnisstring = ergebnisstring + e.getVariant(0) + " <" + e.getVariant(1) + ">";
	      else ergebnisstring = "<" + e.getVariant(1) + ">";
	      ergebnisarray[i-1] = ergebnisstring;
	      if (i < r.rowCount)
	      {
	        e.next();
	      }
	    }
	    return ergebnisarray;
      }
      else return ergebnisarray;
    }
    catch(ex)
    {
      // alert("EVM Error in function evmCreateMailArrayFromDBEntries: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmGetReparsedBody(msgid)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // gets the body for the mail identified by the msgid and calls the parsing
  // function ("evmSplitter")
  function evmGetReparsedBody(msgid)
  {
    try
    {
      var q = "SELECT bodytext FROM body WHERE (msgid = '" + msgid + "')";
      try
      {
        var r = connection.executeQuery(q);
      }
      catch (ex)
      {
        return "evmError";
      }
      if (r.rowCount > 0)
      {
        var e = r.enumerate();
        e.first();
        wurst = e.getVariant(0);
   	    var newbody = evmSplitter(wurst,"35evmDH47","\"");
   	    newbody = evmSplitter(newbody,"75evmSH89","'");
  	    newbody = evmSplitter(newbody,"21evmLT80","<");
	    var anf = "&quot;";
  	    newbody = evmSplitter(newbody,"01evmAF99",anf);
  	    return newbody;
      }
      else return "evmError";
    }
    catch(ex)
    {
      alert("EVM Error in function evmGetParsedBody: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmMsgForwardAsInline(event)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // gets DB entries for the chosen message and fills the composeFields with
  // the values available
  function evmMsgForwardAsInline(event)
  {
    try
    {
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	  include (jslib_io);
	  include(jslib_fileutils);
	  var du = new DirUtils();
      var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");

      var selectedmails = evmGetAllSelectedTreeitems("evmEVMWindowMailviewThreadpaneMailtree",false);
	  for (var EVMx=0; EVMx<selectedmails.length; EVMx++)
	  {
	  	  var newfilename = "";
	  	  var tmpdialog = evmShowWaitDialogue(1,1,-200)
	      tmpdialog.close();
	  	  var selectedindex = tree.treeBoxObject.view.getIndexOfItem(selectedmails[EVMx]);
          var messageID = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid");
          var file = new File(evmGetAttachmentMailDir() + "evmMail_" + messageID + ".evm");
          if (file.exists() == false)
          {
            var composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
            var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(Components.interfaces.nsIMsgComposeParams);
            var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
            var cellcontent = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid");
            var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
            var defaultAccountNormalerweise = pref.getCharPref("mail.accountmanager.defaultaccount");
            // *** get all data for mail
            var originalsender = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSender") + " &lt;" + tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSenderAddress") + ">";
            var originalsubject = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSubject");
            var originalrecipient = evmCreateMailListFromDBEntries("0to",cellcontent,"&lt;",false,true);
            var originalcopies = evmCreateMailListFromDBEntries("1cc",cellcontent,"&lt;",false,false);
            var originalreplyto = evmCreateMailListFromDBEntries("3replyto",cellcontent,"&lt;",false,false);
            var originaldate = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColTimestamp");
            var originalbody = evmGetReparsedBody(cellcontent);
            // *** filling temporary parameters und composeFields
            composeFields.subject = "Fwd: " + originalsubject;
            var evmbody = "<div align='justify'><font face='Arial' size='2' color='#000001'>Hallo&nbsp;<br><br><br><DIV class=3DOutlookMessageHeader dir=3Dltr align=3Dleft><FONT =face=3DTahoma=20 size=3D2>-----Original EVM Message-----<BR>";
            evmbody = evmbody + "<B>From:</B>&nbsp;" + originalsender;
            if(originalreplyto != "evmEmpty") evmbody = evmbody + "<BR><B>ReplyTo:</B>&nbsp;" + originalreplyto;
            evmbody = evmbody + "<BR><B>To:</B>&nbsp;" + originalrecipient;
            if(originalcopies != "evmEmpty") evmbody = evmbody + "<BR><B>Cc:</B>&nbsp;" + originalcopies;
            evmbody = evmbody + "<BR><B>Subject:</B>&nbsp;" + originalsubject;
            evmbody = evmbody + "<BR><B>Date:</B>&nbsp;" + originaldate;
            var ref = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColReferences");
            if(ref != "" && ref != " ") evmbody = evmbody + "<BR><B>References:</B>&nbsp;" + ref;
            evmbody = evmbody + "</FONT></DIV><BR><DIV align=3Djustify><FONT face=3DArial color=3D#000001 size=3D2>" + originalbody + "</FONT></DIV>";
            composeFields.body = evmbody;
            params.composeFields = composeFields;
            var msgComposeService = Components.classes['@mozilla.org/messengercompose;1'].getService();
            msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
            var tmpdialog = evmShowWaitDialogue(1,1,-200)
            tmpdialog.close();
	       	msgComposeService.OpenComposeWindowWithParams(null,params);
          }
          else
          {
            newfilename = "evmTemp_" + messageID;
			var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
          	var f = new File(evmGetMailboxpathFromServerURI("mailbox://nobody@Local%20Folders")+ evmPathSep() + newfilename);
            try {if (f.exists()==true) f.remove();} catch(err) {};
            file.copy(evmGetMailboxpathFromServerURI("mailbox://nobody@Local%20Folders")+ evmPathSep() + newfilename);
            var msgComposeService = Components.classes['@mozilla.org/messengercompose;1'].getService();
            msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
            var tmpdialog = evmShowWaitDialogue(1,1,-200)
            tmpdialog.close();
	       	msgComposeService.OpenComposeWindow(null, "mailbox-message://nobody@Local%20Folders/" + newfilename + "#0",Components.interfaces.nsIMsgCompType.ForwardInline,Components.interfaces.nsIMsgCompFormat.Default,null,null);
            file.close();
            createdFilesInLocalFolder.push(newfilename);
          }
      }
    }
    catch(ex)
    {
      alert("EVM Error in function evmMsgForwardAsInline: " + ex);
      if (newfilename != "")
      {
      	msgComposeService.OpenComposeWindow(null, "mailbox-message://nobody@Local%20Folders/" + newfilename + "#0",Components.interfaces.nsIMsgCompType.ForwardInline,Components.interfaces.nsIMsgCompFormat.Default,null,null);
	  }

    }
  }


  // *************************************************************************
  // function:		evmMsgReply(uno)
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // gets DB entries for the chosen message and fills opens a reply-window
  // with all necessary data
  // the parameter 'uno' can either be 1 or 2: 1 means that you want to reply
  // to the sender only, 2 provides answering to everyone
  function evmMsgReply(uno)
  {
    try
    {
      var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
	  var selectedmails = evmGetAllSelectedTreeitems("evmEVMWindowMailviewThreadpaneMailtree",false);
	  for (var EVMx=0; EVMx<selectedmails.length; EVMx++)
	  {
		var selectedindex = tree.treeBoxObject.view.getIndexOfItem(selectedmails[EVMx]);
        var composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
      	var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(Components.interfaces.nsIMsgComposeParams);
      	var cellcontent = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid");
      	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
      	var defaultAccountNormalerweise = pref.getCharPref("mail.accountmanager.defaultaccount");
	  	// *** search for the right account
      	var query = "SELECT account.address FROM header_mailaddress JOIN mailaddress ON (mailaddressid = id AND msgid = '" + cellcontent + "') JOIN account ON (mailaddress.address = account.address)";
      	try
      	{
          var result = connection.executeQuery(query);
      	}
      	catch(ex) { }
      	try
      	{
          if (result.rowCount >= 0)
          {
            var enumerator = result.enumerate();
            enumerator.first();
            var xc = enumerator.getVariant(0);
		    params.identity = serverArrays[xc];
          }
          else
          {
            recipient = "Not found";
          }
        }
        catch (ex)
        {
        }
	    // *** filling temporary parameters und composeFields
        originalsenderA = [];
        originalsenderA[0] = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSender") + " <" + tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSenderAddress") + ">";
        composeFields.to = originalsenderA;
        if(uno == "2")
        {
          oldtos = evmCreateMailArrayFromDBEntries("0to",cellcontent);
          oldtosl = oldtos.length;
          oldccs = evmCreateMailArrayFromDBEntries("1cc",cellcontent);
          for(var j = oldtos.length; j <= (oldtosl + oldccs.length - 1); j++)
          {
            oldtos[j] = oldccs[j-oldtosl];
          }
          oldccs = [];
          oldccsCount = 0;
          for(var k = 0; k < oldtos.length; k++)
          {
            var meins = false;
            for(var l = 0; l < gAddressArray.length; l++)
            {
              if(oldtos[k].indexOf(gAddressArray[l]) >= 0) meins = true;
            }
            if(meins == false)
            {
              oldccs[oldccsCount] = oldtos[k];
              oldccsCount++;
            }
          }
          composeFields.cc = oldccs;
        }
	    var originalbody = evmGetReparsedBody(cellcontent);
        composeFields.subject = "Re: " + tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSubject");
      	evmbody = "<div align='justify'><font face='Arial' size='2' color='#000001'>Hallo&nbsp;<br><br><br><DIV class=3DOutlookMessageHeader dir=3Dltr align=3Dleft><FONT =face=3DTahoma=20 size=3D2>-----Original EVM Message-----<BR>";
      	evmbody = evmbody + "<B>From:</B>&nbsp;" + tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSender") + " &lt;" + tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSenderAddress") + ">";
		var originalreplyto = evmCreateMailListFromDBEntries("3replyto",cellcontent,"&lt;",false,true);
	  	if(originalreplyto != "evmEmpty") evmbody = evmbody + "<BR><B>ReplyTo:</B>&nbsp;" + originalreplyto;
      	evmbody = evmbody + "<BR><B>To:</B>&nbsp;" + evmCreateMailListFromDBEntries("0to",cellcontent,"&lt;",false,false);
	  	var originalcopies = evmCreateMailListFromDBEntries("1cc",cellcontent,"&lt;",false,false);
     	if(originalcopies != "evmEmpty") evmbody = evmbody + "<BR><B>Cc:</B>&nbsp;" + originalcopies;
      	evmbody = evmbody + "<BR><B>Subject:</B>&nbsp;" + tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSubject");
      	evmbody = evmbody + "<BR><B>Date:</B>&nbsp;" + tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColTimestamp");
	 	var ref = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColReferences");
	  	if(ref != "" && ref != " ") evmbody = evmbody + "<BR><B>References:</B>&nbsp;" + ref;
      	evmbody = evmbody + "</FONT></DIV><BR><DIV align=3Djustify><FONT face=3DArial color=3D#000001 size=3D2>" + originalbody + "</FONT></DIV>";
      	composeFields.body = evmbody;
      	composeFields.references = "<" + cellcontent + ">";
      	params.composeFields = composeFields;
      	var msgComposeService = Components.classes['@mozilla.org/messengercompose;1'].getService();
      	msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
      	msgComposeService.OpenComposeWindowWithParams(null,params);
		var tmpdialog = evmShowWaitDialogue(1,1,-200)
		tmpdialog.close();
      }
	}
    catch(ex)
    {
      alert("EVM Error in function evmMsgReply: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmInitializeCategorytrees(treename,array)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // initializes the category-trees in the tree identified by the 'treename'
  // parameter; data is retrieved from DB ordered by the parent-IDs. Top-
  // categories have 0 as their childof value.
  // id and name are stored as found in DB, while the parent id is either
  // "evmTopcategory471155552006" for topcategories, or -for subcategories-
  // the parent id as stored in the parent id parameter
  function evmInitializeCategorytrees(treename,array)
  {
	try
	{
	  // *** filling temporary parameters: ids, names, and parent category
      var query = "SELECT id, name, childof FROM category ORDER BY childof, name";
      var categoryObject = {};
      var categoryCountArray = [];
      var categoryCount = -1;
      try
      {
        var result = connection.executeQuery(query);
      }
      catch(ex) { }
      try
      {
        if (result.rowCount >= 0)
        {
          var enumerator = result.enumerate();
          enumerator.first();
   	      for(var i = 1; i <= result.rowCount; i++)
  	      {
		    categoryCount++;
		    categoryCountArray[categoryCount] = parseInt(enumerator.getVariant(0));
		    categoryObject[enumerator.getVariant(0)+"id"] = treename + enumerator.getVariant(0);
		    categoryObject[enumerator.getVariant(0)+"name"] = enumerator.getVariant(1);
		    if(enumerator.getVariant(2) == 0) categoryObject[enumerator.getVariant(0)+"top"] = "evmTopcategory471155552006";
		    else categoryObject[enumerator.getVariant(0)+"top"] = treename + categoryObject[enumerator.getVariant(2) + "id"];
	        if (i < result.rowCount) enumerator.next();
	      }
        }
      }
      catch (ex)
      {
      }
	  // *** adding categories to tree
	  for(var i = 0; i <= categoryCount; i++)
	  {
	    var columnitems = [];
	    columnitems[0] = categoryObject[categoryCountArray[i] + "name"];
	    var cid = categoryObject[categoryCountArray[i] + "id"];
	    columnitems[1] = cid;
	    if(array != [])
	    {
	      if(array[categoryCountArray[i].toString()])
	        columnitems[2] = array[categoryCountArray[i].toString()];
	    }
	    if(categoryObject[categoryCountArray[i] + "top"] == "evmTopcategory471155552006") evmCreateTreeItem(treename, columnitems, cid, treename + "children", false);
	    else evmCreateTreeItem(treename, columnitems, cid, categoryObject[categoryCountArray[i] + "top"], false);
	  }
	}
    catch(ex)
    {
      alert("EVM Error in function evmInitializeCategorytrees: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmInitializeSearchtrees(treename,array)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // initializes the search-trees from the DB into the searchpane
  function evmInitializeSearchtrees(treename,array)
  {
    var query = "SELECT id, name, childof FROM search ORDER BY childof, name";
  	try
    {
      var result = connection.executeQuery(query);
    }
    catch(ex) { }
    try
    {
      if (result.rowCount >= 0)
      {
        var enumerator = result.enumerate();
        enumerator.first();
   	    for(var i = 1; i <= result.rowCount; i++)
  	    {
  	      var cid = enumerator.getVariant(0);
  	      var columnitems = [enumerator.getVariant(1)];
  	      var childof;
  	      if (enumerator.getVariant(2)==0)
  	        childof = treename + "children";
  	      else
  	        childof = treename + enumerator.getVariant(2);
  	  	  evmCreateTreeItem(treename, columnitems, cid, childof, false);
		  enumerator.next();
  		}
  	  }
 	}
 	catch(err)
 	{
 	}
  }

  // *************************************************************************
  // function:		evmMailviewfolderpaneboxselected(orderby,direction,newopen)
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // this is a kind of an event handler: it deletes the threadpane and calls
  // evmInitializeThreadpaneConcerningCategory(category) to build up the tree
  // again
  function evmMailviewfolderpaneboxselected(orderby,direction,newopen)
  {
  	try
	{
	  var sqlstatement = "";
	  if (selected==2)
	  {
	  	var elements = evmGetAllSelectedTreeitems("evmEVMWindowMailviewFolderpaneboxSearchtree",false);
		var searchid = elements[0].getAttribute("DBid");
		var query = "Select searchstring from search where id=" + searchid;
		try{var result = connection.executeQuery(query);} catch(err){};
   		var enumerator = result.enumerate();
	   	enumerator.first();
		sqlstatement = "WHERE " + evmSearchGenerateGetSQL(enumerator.getVariant(0),true);
	  }

	  evmEmptyCache();
	  document.getElementById("evmEVMWindowMailviewMessagepaneBrowser").setAttribute('src',"about:blank");
	  var categorytree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtreechildren");
	  while(categorytree.firstChild!=null)
	  {
	    categorytree.removeChild(categorytree.firstChild);
	  }
	  categorytree.parentNode.setAttribute("container","false");
	  var tree = document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytree");
      try
      {
        var cellcontent = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewFolderpaneboxCategorytreeTreecolDbid");
      }
      catch(ex)
      {
        var cellcontent = tree.treeBoxObject.view.getCellText(tree.firstChild,"evmEVMWindowMailviewFolderpaneboxCategorytreeTreecolDbid");
        tree.treeBoxObject.selection.select(0);
      }
	  var honk = cellcontent.split("EVMWindowMailviewFolderpaneboxCategorytree");
      var wurst = parseInt(honk[1]);
      evmInitializeThreadpaneConcerningCategory(wurst,orderby,direction,newopen,sqlstatement);
    }
    catch(ex)
    {
    }
  }


  // *************************************************************************
  // function:		evmIsInteger(pruef)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // even if parseInt(...) is used on a parameter, we still don't know whether
  // the parameter really is a number, so we use this trick here:
  // a string (e.g. "Hi") plus 5 plus 5 equals "Hi55" which is not the same as
  // the string plus 10 (= "Hi10").
  // a number plus 5 plus 5 equals as much as the number plus 10! :-)
  function evmIsInteger(pruef)
  {
    return (((pruef+5)+5) == (pruef+10));
  }


  // *************************************************************************
  // function:		evmWriteMozillaAccountsToDB()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // walking through all servers and writing user-email to DB
  function evmWriteMozillaAccountsToDB()
  {
    try
    {
      var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
      var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
      var allServers = accountManager.allServers;
      var allServersArray = pref.getCharPref("mail.accountmanager.accounts").split(",");
      var numServers = allServers.Count();
      var serverArray = [];
      var addressCount = -1;
      var aktuelleServerNummer;
      var j;
	  // *** walking through servers as stored in the preferences
      for (var index = 0; index < allServersArray.length; index++)
      {
	    aktuelleServerNummer = "mail.account." + allServersArray[index] + ".server";
	    if(pref.getCharPref("mail.accountmanager.localfoldersserver") != pref.getCharPref(aktuelleServerNummer))
	    {
	      addressCount = addressCount + 1;
	      serverArray[addressCount] = allServers.GetElementAt(index).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
          var idnummer = pref.getCharPref("mail.account." + allServersArray[index] + ".identities");
	      gAddressArray[addressCount] = pref.getCharPref("mail.identity." + idnummer + ".useremail");
	      serverArrays[gAddressArray[addressCount]] = accountManager.getFirstIdentityForServer(serverArray[addressCount]); // "account" + j;
	      var vorhanden = false;
	      try
	      {
		    query = "select (id) from account where (address ='" + gAddressArray[addressCount] + "')";
	        var result = connection.executeQuery(query);
	        // die nachfolgenden Zeilen werden nur erreicht, wenn Account vorhanden
	        var enumerator = result.enumerate();
	        enumerator.first();
	        ergebnis = enumerator.getVariant(0);
	        schonda = parseInt(ergebnis);
	        if(evmIsInteger(schonda)) vorhanden = true;
	      }
	      catch (ex)
	      {
	      }
	      if(vorhanden == false)
          {
	  	    query = "select max(id) from account";
	        result = connection.executeQuery(query);
	        enumerator = result.enumerate();
	        enumerator.first();
	        ergebnis = enumerator.getVariant(0);
	        s = parseInt(ergebnis);
	        if(evmIsInteger(s)) s = s + 1;
	        else s = 0;
	        sql_headerfields = "id, address, realname";
            sql_headervalues = s + ",'" + gAddressArray[addressCount] + "','nix'";
	        try
  	        {
              query = "INSERT INTO account (" + sql_headerfields + ") VALUES (" + sql_headervalues + ")";
              result = connection.executeQuery(query);
            }
            catch (ex)
            {
              if(connection.errormessage) alert("Inserting Account failed: " +  connection.errormessage);
            }
	      }
	    } // if
      } // for
      return true;
    } // try
    catch(ex)
    {
      // alert("EVM Error in function evmWriteMozillaAccountsToDB: " + ex);
      return false;
    }
  }


  // *************************************************************************
  // function:		evmUpdateCategorytrees()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // deletes the left categorytrees in both tabpanels and re-builds them
  function evmUpdateCategorytrees()
  {
    try
    {
      var howmany = {};
      try
      {
	    query = "select categoryid from header_category";
        result = connection.executeQuery(query);
      }
      catch(ex) { }
      try
      {
        if(evmIsEntryAvailableInDB(result))
        {
	  	  var e = result.enumerate();
      	  e.first();
	  	  for(var i = 1; i <= result.rowCount; i++)
	      {
		    howmany[e.getVariant(0)] = 0; // defining
	        if (i < result.rowCount)
	        {
	          e.next();
	        }
	      }
      	  e.first();
	  	  for(var i = 1; i <= result.rowCount; i++)
	      {
		    howmany[e.getVariant(0)]++; // counting
	        if (i < result.rowCount)
	        {
	          e.next();
	        }
	      }
        }
      }
      catch(ex)
      {
      }
	  var categorytree = document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytreechildren");
	  while(categorytree.firstChild!=null)
	  {
	    categorytree.removeChild(categorytree.firstChild);
	  }
	  categorytree.parentNode.setAttribute("container","false");
	  var tmpcid = -1232006;
      try
      {
	    query = "select categoryid, msgid from header_category where (categoryid =" + tmpcid + ")";
        result = connection.executeQuery(query);
      }
      catch(ex) { }
      try
      {
        if(evmIsEntryAvailableInDB(result))
        {
		  var columnitems = [];
		  columnitems[0] = "evmHasNoCategory";
		  columnitems[1] = "evmEVMWindowMailviewFolderpaneboxCategorytree-1232006";
		  columnitems[2] = howmany["-1232006"];
		  evmCreateTreeItem("evmEVMWindowMailviewFolderpaneboxCategorytree", columnitems, "-1232006", "evmEVMWindowMailviewFolderpaneboxCategorytreechildren", false);
		  gHasMailsWithNoCategory = true;
        }
      }
      catch(ex)
      {
      }
	  evmInitializeCategorytrees("evmEVMWindowMailviewFolderpaneboxCategorytree",howmany);
	  var columnitems = [];
	  columnitems[0] = "evmTrash";
	  columnitems[1] = "evmEVMWindowMailviewFolderpaneboxCategorytree-7011980";
	  if(howmany["-7011980"]) columnitems[2] = howmany["-7011980"];
	  else columnitems[2] = 0;
	  evmCreateTreeItem("evmEVMWindowMailviewFolderpaneboxCategorytree", columnitems, "-7011980", "evmEVMWindowMailviewFolderpaneboxCategorytreechildren", false);
	  categorytree = document.getElementById("evmEVMWindowCategoryFolderpaneboxCategorytreechildren");
	  while(categorytree.firstChild!=null)
	  {
	    categorytree.removeChild(categorytree.firstChild);
	  }
	  categorytree.parentNode.setAttribute("container","false");
	  evmInitializeCategorytrees("evmEVMWindowCategoryFolderpaneboxCategorytree",[]);
	}
    catch(ex)
    {
      alert("EVM Error in function evmUpdateCategorytrees: " + ex);
    }
  }

  function evmUpdateSearchtrees()
  {
  	var searchtree = document.getElementById("evmEVMWindowMailviewFolderpaneboxSearchtreechildren");
	while(searchtree.firstChild!=null)
	{
	  searchtree.removeChild(searchtree.firstChild);
	}
	evmInitializeSearchtrees("evmEVMWindowMailviewFolderpaneboxSearchtree",[])
  }


  // *************************************************************************
  // function:		evmInitializeThreadpaneConcerningCategory(category,orderbycolumn,orderdirection)
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // fills the threadpane concering the passed category
  function evmInitializeThreadpaneConcerningCategory(category,orderbycolumn,ordertype,newopen,sqlstatement)
  {
	try
	{
	  if (globalorderbycolumn == orderbycolumn && globalordertype == ordertype)
	  {
	  	if (newopen==false)
	  	{
	  	  if (ordertype==1) ordertype=0;
	  	  else ordertype=1;
	  	}
	  }
	  globalorderbycolumn = orderbycolumn;
	  globalordertype = ordertype;
	  var direction;
	  if (ordertype==1) direction = "DESC";
	  else direction = "ASC";
	  if (orderbycolumn==1) orderby = "date " + direction + ", time " + direction
	  if (orderbycolumn==2) orderby = "mailaddress.address " + direction;
	  if (orderbycolumn==3) orderby = "header.msgid " + direction;
	  if (orderbycolumn==4) orderby = "mailaddress.realname " + direction;
	  if (orderbycolumn==5) orderby = "subject " + direction;
      if (sqlstatement != "" && sqlstatement != null)
      {
	    query = "SELECT header.id, header.msgid, mailaddress.realname, subject, mailaddress.address, date, time, ref, tstamp FROM header JOIN mailaddress ON (header.sender = mailaddress.id) " + sqlstatement + " ORDER BY " + orderby;
	  }
      else
      {
      	query = "SELECT header.id, header.msgid, mailaddress.realname, subject, mailaddress.address, date, time, ref, tstamp FROM header JOIN mailaddress ON (header.sender = mailaddress.id) JOIN header_category ON (header.msgid = header_category.msgid AND categoryid=" + category + ") ORDER BY " + orderby;
      }
      try
      {
        var result = connection.executeQuery(query);
      }
      catch(ex)
      {
      }
      try
      {
        if (result.rowCount > 0)
        {
	      var columnitems = [];
          var enumerator = result.enumerate();
          enumerator.first();
   	      for(var i = 1; i <= result.rowCount; i++)
  	      {
		    columnitems[0] = enumerator.getVariant(1); // msg-id
		    columnitems[1] = enumerator.getVariant(7); // references
		    columnitems[2] = enumerator.getVariant(2); // sender-realname
		    columnitems[3] = enumerator.getVariant(4); // sender-address
		    c = evmCreateMailListFromDBEntries("3replyto",enumerator.getVariant(1),"<",false,true); // replyto-addr
		    if(c == "evmEmpty") columnitems[4] = "-none-";
		    else columnitems[4] = c;
		    columnitems[5] = evmCreateMailListFromDBEntries("0to",enumerator.getVariant(1),"<",true,false); // recipientsTo-realnames
		    columnitems[6] = evmCreateMailListFromDBEntries("0to",enumerator.getVariant(1),"<",false,false); // recipientsTo-addr
		    c = evmCreateMailListFromDBEntries("1cc",enumerator.getVariant(1),"<",true,false); // recipientsCC-realname
		    if(c == "evmEmpty") columnitems[7] = "-none-";
		    else columnitems[7] = c;
		    c = evmCreateMailListFromDBEntries("2bcc",enumerator.getVariant(1),"<",true,false); // recipientsBCC-realname
		    if(c == "evmEmpty") columnitems[8] = "-none-";
		    else columnitems[8] = c;
		    columnitems[9] = enumerator.getVariant(3); // subject
		    columnitems[10]= enumerator.getVariant(5) + " " + enumerator.getVariant(6); // date+time
		    columnitems[11]= enumerator.getVariant(8); // timestamp
		    var folderquery = "SELECT category.name, category.id FROM header_category JOIN category ON (header_category.categoryid=category.ID) WHERE header_category.msgid='" +  columnitems[0] + "'";
		    try
		    {
		    	columnitems[12] = "";
		    	var result2 = connection.executeQuery(folderquery);
		    	var enumerator2 = result2.enumerate();
		    	enumerator2.first();
				for (var y=1; y<=result2.rowCount; y++)
				{
					columnitems[12] = columnitems[12] + enumerator2.getVariant(0) + "; ";
					if (y < result2.rowCount) enumerator2.next();
				}
			}
			catch(err)
			{}
 	  	    evmCreateTreeItem("evmEVMWindowMailviewThreadpaneMailtree", columnitems, enumerator.getVariant(0), "evmEVMWindowMailviewThreadpaneMailtreechildren", false);
	        if (i < result.rowCount) enumerator.next();
	      }
        }
        else
        {
          recipient = "Not found";
        }
      }
      catch (ex)
      {
        // alert("evmInitializeThreadpaneConcerningCategory: " + ex);
      }
    }
    catch(ex)
    {
      alert("EVM Error in function evmInitializeThreadpaneConcerningCategory: " + ex);
    }

    if (selected==1)
		document.getElementById("evmEVMWindowMailviewFolderpaneboxSearchtree").view.selection.select(-1);
	else
		document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytree").view.selection.select(-1);
  }


  // *************************************************************************
  // function:		evmInitializeEVM()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // calls the functions necessary to build category-trees, etc
  function evmInitializeEVM()
  {
    try
    {
      evmInitConnection();
	  // *** checking Mozilla-Accounts
	  var everythings_okay = evmWriteMozillaAccountsToDB();
	  if(everythings_okay == false)
	  {
	    alert("A major error occured: probably no DB connection established!");
	    return;
	  }
	  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  try
	  {
	    sizemax = pref.getIntPref("evm.cachesizeKB") * 1020;
	  }
	  catch(ex)
	  {
	    sizemax = 10000;
	  }
	  // *** choosing the right tabbox
	  var tmpcid = -1232006;
      try
      {
	    query = "select categoryid, msgid from header_category where (categoryid =" + tmpcid + ")";
        result = connection.executeQuery(query);
      }
      catch(ex) { }
      try
      {
        if(evmIsEntryAvailableInDB(result))
        {
          evmChangePaneTo(2);
        }
      }
      catch(ex)
      {
      }
	  document.getElementById("evmEVMWindowCategoryButtonIn").setAttribute('disabled',true);
	  document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemSelect").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonOut").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonOk").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonSubcategory").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonRenamecategory").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonDeletecategory").setAttribute('disabled',true);

	  evmUpdateCategorytrees();
	  evmUpdateSearchtrees();
	  // *** disable mailbuttons
      document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonReply").setAttribute('disabled',true); // reply-Button
      document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonReplyall").setAttribute('disabled',true); // replyAll-Button
      document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonForward").setAttribute('disabled',true); // forward-Button
      document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonDelete").setAttribute('disabled',true); // delete-Button
	  // *** disable categorytabbox buttons
      document.getElementById("evmEVMWindowCategoryButtonOut").setAttribute('disabled',true); // CategoryTabbox: <-
	  document.getElementById("evmEVMWindowCategoryButtonOk").setAttribute('disabled',true); // CategoryTabbox: OK
	  evmCategoriesToPopup('evmEVMWindowMailviewFolderpaneboxCategorytree','evmEVMWindowMailviewFolderpaneboxCategorytreeTreecolCategory','copytomenu');
	  evmCategoriesToPopup('evmEVMWindowMailviewFolderpaneboxCategorytree','evmEVMWindowMailviewFolderpaneboxCategorytreeTreecolCategory','movetomenu');

	}
    catch(ex)
    {
      alert("EVM Error in function evmInitializeEVM: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmDisableMailButtons(b)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // disables or enables mailbuttons (reply, replyAll, forward, delete), e.g.
  // in case that no mail is chosen
  // the parameter 'b' is the boolean parameter which indicates whether we want
  // to disable (true) or enable (false)
  function evmDisableMailButtons(b)
  {
  	if(b == false)
    {
      var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
	  if (tree.treeBoxObject.selection.count == 0) return;
    }
    document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonReply").setAttribute('disabled',b); // reply-Button
    document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonReplyall").setAttribute('disabled',b); // replyAll-Button
    document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonForward").setAttribute('disabled',b); // forward-Button

    if (selected == 1)
      document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonDelete").setAttribute('disabled',b); // delete-Button
    else
      document.getElementById("evmEVMWindowMailviewToolboxToolbarButtonDelete").setAttribute('disabled','true'); // delete-Button
  }

  // *************************************************************************
  // function:		evmDisableSearchButtons()
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // disables or enables searchbuttons (edit, delete)
  // in case that no search is chosen
  function evmDisableSearchButtons()
  {
    try
    {
  	  if (evmGetAllSelectedTreeitems("evmEVMWindowMailviewFolderpaneboxSearchtree",false).length > 0)
      {
  	    document.getElementById("evmEVMWindowMailviewSearchToolboxToolbarButtonEditsearch").setAttribute('disabled','false');
  	    document.getElementById("evmEVMWindowMailviewSearchToolboxToolbarButtonDelsearch").setAttribute('disabled','false');
  	    document.getElementById("evmEVMWindowTabpanelMailviewSearchPopupsetMenuitemDelete").setAttribute('disabled','false');
  	    document.getElementById("evmEVMWindowTabpanelMailviewSearchPopupsetMenuitemEdit").setAttribute('disabled','false');
  	  }
  	  else
   	  {
  	    document.getElementById("evmEVMWindowMailviewSearchToolboxToolbarButtonEditsearch").setAttribute('disabled','true');
  	    document.getElementById("evmEVMWindowMailviewSearchToolboxToolbarButtonDelsearch").setAttribute('disabled','true');
  	    document.getElementById("evmEVMWindowTabpanelMailviewSearchPopupsetMenuitemDelete").setAttribute('disabled','true');
  	    document.getElementById("evmEVMWindowTabpanelMailviewSearchPopupsetMenuitemEdit").setAttribute('disabled','true');
  	  }
  	}
  	catch(err)
  	{
  	}
  }


  // *************************************************************************
  // function:		evmDeleteMarkedMessage(ask,emptytrash)
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // this button provides 'deleting' mails from the EVM
  // deleting from a normal category will only move the mail to the evmTrash,
  // deleting from evmTrash will delete the message completly
  function evmDeleteMarkedMessage(ask, emptytrash)
  {
	var categorytree = document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytree");
	var categoryindex = categorytree.treeBoxObject.selection.currentIndex;
	try
	{
      var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
      var cellcontentCategory = document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytree").treeBoxObject.view.getCellText(document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytree").currentIndex,"evmEVMWindowMailviewFolderpaneboxCategorytreeTreecolDbid");
      var honk = cellcontentCategory.split("EVMWindowMailviewFolderpaneboxCategorytree");
      var wurst = parseInt(honk[1]);
      var tmpcid = -7011980;
	  var deleteKandidatIndex = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree").treeBoxObject.selection.currentIndex;
      if(wurst != tmpcid)
      {
	    try
        {
          var selectedelements = evmGetAllSelectedTreeitems("evmEVMWindowMailviewThreadpaneMailtree",false);
		  for (var x=0; x<selectedelements.length; x++)
          {
            var currentelement = selectedelements[x];
            var parentelement = currentelement.parentNode;
            var Mid = evmGetCell('evmEVMWindowMailviewThreadpaneMailtree','evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid',currentelement);
            var testquery = "Select * FROM header_category WHERE msgid='" + Mid + "' AND categoryid='" + tmpcid + "'";
	 		try {var tmpresult = connection.executeQuery(testquery);} catch(err){};
	 		if (tmpresult.rowCount > 0)
	 			query = "DELETE FROM header_category WHERE msgid='" + Mid + "' AND categoryid='" + wurst +"'";
	 		else
	 	 		query = "UPDATE header_category SET categoryid='" + tmpcid + "' WHERE (categoryid='" + wurst + "' AND msgid='" + Mid + "')";
	 		try {var result = connection.executeQuery(query);} catch(err){};
	      }
        }
        catch(ex)
        {
          alert(ex);
        }
      }
      else
      {
      	if (ask == true && confirm("Do you really want to PERMANENTLY delete this message!?") == true) ask = false;
        if (ask == false)
      	{
      	  var selectedmails = evmGetAllSelectedTreeitems("evmEVMWindowMailviewThreadpaneMailtree",emptytrash);
		  for (var EVMx=0; EVMx<selectedmails.length; EVMx++)
		  {
			var selectedindex = tree.treeBoxObject.view.getIndexOfItem(selectedmails[EVMx]);
      	   	var cellcontentMailid = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid");
	        try { connection.executeQuery("DELETE FROM header_category WHERE (msgid ='" + cellcontentMailid + "' AND categoryid =" + wurst + ")"); } catch(ex) { }
            try
            {
              q = "select categoryid from header_category where (msgid='" + cellcontentMailid + "')";
              try
              {
                r = connection.executeQuery(q);
              }
              catch(ex) { }
              if(evmIsEntryAvailableInDB(r) == true) { alert("Message with MsgID " + cellcontentMailid + " was probably not deleted properly!"); }
              else
              {
                try { connection.executeQuery("DELETE FROM attachment WHERE (msgid ='" + cellcontentMailid + "')"); } catch(ex) { }
                try { connection.executeQuery("DELETE FROM body WHERE (msgid ='" + cellcontentMailid + "')"); } catch(ex) { }
                try { connection.executeQuery("DELETE FROM header WHERE (msgid ='" + cellcontentMailid + "')"); } catch(ex) { }
                try { connection.executeQuery("DELETE FROM header_mailaddress WHERE (msgid ='" + cellcontentMailid + "')"); } catch(ex) { }
              }
            }
            catch(ex)
            {
              // alert(ex);
            }
	      	evmXDeleteFile(evmGetAttachmentMailDir() + "evmMail_" + cellcontentMailid + ".evm",false);
	      	document.getElementById("evmEVMWindowMailviewMessagepaneBrowser").setAttribute('src',"about:blank");
	      	bodycache[cellcontentMailid] = "evmDeleted";
	      	evmRemoveToofastclicksRests();
		  }
        }
      } // else
	  evmRefreshView("evmEVMWindowMailviewThreadpaneMailtree", "evmEVMWindowMailviewFolderpaneboxCategorytree")
	  evmInitializeEVM();
	  categorytree.view.selection.select(categoryindex);
    }
    catch(ex)
    {
      alert("EVM Error in function evmDeleteMarkedMessage: " + ex);
    }
  }


  var numberOfChosenCategories = 0;
  var ChosenCategories = {};


  // *************************************************************************
  // function:		evmAppendChosenCategories()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // appends chosen categories to the chosen category tree
  function evmAppendChosenCategories()
  {
	try
	{
	  if(gHasMailsWithNoCategory == false) return;
      var tree = document.getElementById("evmEVMWindowCategoryFolderpaneboxCategorytree");

      var selectedmails = evmGetAllSelectedTreeitems("evmEVMWindowCategoryFolderpaneboxCategorytree",false);
	  for (var EVMx=0; EVMx<selectedmails.length; EVMx++)
	  {
		var selectedindex = tree.treeBoxObject.view.getIndexOfItem(selectedmails[EVMx]);
       	var cellcontent = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowCategoryFolderpaneboxCategorytreeTreecolCategory");
      	var cellcontentid = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowCategoryFolderpaneboxCategorytreeTreecolDbid");
	  	var columnitems = [];
      	columnitems[0] = cellcontent;
      	var what = cellcontentid.split("EVMWindowCategoryFolderpaneboxCategorytree");
      	columnitems[1] = what[1];
	  	var testpassed = true;
	  	try
	  	{
	    	if(ChosenCategories[what[1]] == cellcontent) testpassed = false;
	    	if(ChosenCategories[what[1]] == "empty") testpassed = true;
	  	}
	  	catch(ex)
	  	{
	    	testpassed = true;
	  	}
	  	if(testpassed == true)
	  	{
      	  ChosenCategories[what[1]] = cellcontent;
      	  numberOfChosenCategories++;
	  	  evmCreateTreeItem("evmEVMWindowCategoryFolderpaneboxChosencategorytree", columnitems, numberOfChosenCategories, "evmEVMWindowCategoryFolderpaneboxChosencategorytreechildren", false);
      	  document.getElementById("evmEVMWindowCategoryButtonOut").setAttribute('disabled',false);
      	  document.getElementById("evmEVMWindowCategoryButtonIn").setAttribute('disabled',true);
      	  document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemSelect").setAttribute('disabled',true);
	  	  document.getElementById("evmEVMWindowCategoryButtonOk").setAttribute('disabled',false);
	  	}
	  }
	}
    catch(ex)
    {
      // alert("EVM Error in function evmAppendChosenCategories: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmInsertIntoChosenCategories()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // is called by the 'OK'-Button in the second tabpanel, and finds all msgids
  // from the DB which don't have a proper category yet, saves them into the
  // msgidArray, reads all chosen categories and inserts every msgid into the
  // DB with its chosen categories
  // in the end, the buttons are disabled, and the tabpanel is swichted to the
  // first one
  function evmInsertIntoChosenCategories()
  {
	try
	{
	  if(gHasMailsWithNoCategory == false) return;
	  if(numberOfChosenCategories == 0) return;
	  var tmpcid = -1232006;
	  var categorytree = document.getElementById("evmEVMWindowCategoryFolderpaneboxChosencategorytreechildren");
	  while(categorytree.firstChild!=null)
	  {
	    categorytree.removeChild(categorytree.firstChild);
	  }
	  categorytree.parentNode.setAttribute("container","false");
      try
      {
	    query = "select categoryid, msgid from header_category where (categoryid =" + tmpcid + ")";
	    var msgidArray = [];
	    var msgidArrayCount = -1;
        result = connection.executeQuery(query);
      }
      catch(ex)
      {
      }
      try
      {
        if(evmIsEntryAvailableInDB(result))
        {
          enumerator = result.enumerate();
          enumerator.first();
	      for(var i = 1; i <= result.rowCount; i++)
		  {
            msgidArrayCount++;
            msgidArray[msgidArrayCount] = enumerator.getVariant(1);
            if (i < result.rowCount) enumerator.next();
          }
          query = "delete from header_category where (categoryid =" + tmpcid + ")";
          try
          {
            result = connection.executeQuery(query);
          }
          catch(ex)
          {
          }
          for(e in ChosenCategories)
		  {
	  	    if(ChosenCategories[e] != "empty")
	  	    {
	  	      for(var j = 0; j <= msgidArrayCount; j++)
	  	      {
	  	        try
          	    {
        		  sql_headerfields = "msgid, categoryid";
        		  var wurst = parseInt(e);
                  sql_headervalues= "'" + msgidArray[j] + "'," + wurst;
        		  query = "INSERT INTO header_category (" + sql_headerfields + ") VALUES (" + sql_headervalues + ")";
	    		  var result = connection.executeQuery(query);
          	    }
          	    catch(ex)
          	    {
          	    }
	  	      }
	  	    } // if
	  	  } // for
	    } // if
	  } // try
	  catch(ex)
	  {
	  }
	  document.getElementById("evmEVMWindowCategoryButtonIn").setAttribute('disabled',true);
	  document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemSelect").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonOut").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonOk").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonCancel").setAttribute('disabled',true);
	  evmUpdateCategorytrees();
	  gHasMailsWithNoCategory = false;
	  numberOfChosenCategories = 0;
	  evmChangePaneTo(1);
	}
    catch(ex)
    {
      alert("EVM Error in function evmInsertIntoChosenCategories: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmDeleteChosenCategories()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // deletes chosen categories from the chosen-category-tree
  function evmDeleteChosenCategories()
  {
	try
	{
	  if(gHasMailsWithNoCategory == false) return;
	  var tree = document.getElementById("evmEVMWindowCategoryFolderpaneboxChosencategorytree");

	  var selectedmails = evmGetAllSelectedTreeitems("evmEVMWindowCategoryFolderpaneboxChosencategorytree",false);
	  for (var EVMx=0; EVMx<selectedmails.length; EVMx++)
	  {
	  	var selectedindex = tree.treeBoxObject.view.getIndexOfItem(selectedmails[EVMx]);
	   	var currentelement = tree.treeBoxObject.view.getItemAtIndex(selectedindex);
      	var cellcontentid = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowCategoryFolderpaneboxChosencategorytreeTreecolDbid");
      	var what = cellcontentid.split("EVMWindowCategoryFolderpaneboxCategorytree");
      	ChosenCategories[cellcontentid] = "empty";
	  	var parentelement = currentelement.parentNode;
	  	parentelement.removeChild(currentelement);
        numberOfChosenCategories--;
      	if(numberOfChosenCategories == 0)
      	{
          document.getElementById("evmEVMWindowCategoryButtonOut").setAttribute('disabled',true);
          document.getElementById("evmEVMWindowCategoryButtonOk").setAttribute('disabled',true);
      	}
	  }
    }
    catch(ex)
    {
      // alert("EVM Error in function evmDeleteChosenCategories: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmCloseEVMWithoutChosenCategories()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // is called by the 'Cancel'-Button in the second tabpanel (works even if
  // disabled ;-))
  function evmCloseEVMWithoutChosenCategories()
  {
	try
	{
	  if(gHasMailsWithNoCategory == false)
	  {
	    window.close();
	    return;
	  }
      if (confirm("There are mails which do not have a Category yet. If you press 'OK' now, this window will be closed, but the mails (which you can all see in the Mailview Tabpanel folder evmHasNoCategory) will be remembered for the next time you open this window. If you do not want one, more or any of these mails to be saved in the category you are going to choose next, please remove it from the folder (if you press 'Cancel' now, we will take you to the tabpanel Mailview)!")==true)
      {
        gHasMailsWithNoCategory = false;
        window.close();
      }
      else
        evmChangePaneTo(1);
    }
    catch(ex)
    {
      alert("EVM Error in function evmCloseEVMWithoutChosenCategories: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmInitializeAddressbooktree()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // inserts all e-mail-address and realnames into the third tabpanel
  function evmInitializeAddressbooktree()
  {
	try
	{
	  var atree = document.getElementById("evmEVMWindowAddressesAddresstreechildren");
	  while(atree.firstChild!=null)
	  {
	    atree.removeChild(atree.firstChild);
	  }
	  atree.parentNode.setAttribute("container","false");

      var query = "SELECT id, address, realname FROM mailaddress ORDER BY UPPER(realname), address";
      try
      {
        var result = connection.executeQuery(query);
      }
      catch(ex)
      {
      }
      try
      {
        if (result.rowCount >= 0)
        {
          var enumerator = result.enumerate();
          enumerator.first();
   	      for(var i = 1; i <= result.rowCount; i++)
  	      {
		    columnitems = [];
		    columnitems[0] = enumerator.getVariant(2);
		    columnitems[1] = enumerator.getVariant(1);
		    columnitems[2] = enumerator.getVariant(0);
		    evmCreateTreeItem("evmEVMWindowAddressesAddresstree", columnitems, enumerator.getVariant(0), "evmEVMWindowAddressesAddresstreechildren", false);
	        if (i < result.rowCount) enumerator.next();
	      }
        }
      }
      catch (ex)
      {
      }
      document.getElementById("evmEVMWindowAddressesButtonChange").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowAddressesButtonDelete").setAttribute('disabled',true);
    }
    catch(ex)
    {
      alert("EVM Error in function evmInitializeAddressbooktree: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmChangeRealnameOfMailaddress()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // provides renaming a DB entry conering the realname
  function evmChangeRealnameOfMailaddress()
  {
    try
    {
      var tree = document.getElementById("evmEVMWindowAddressesAddresstree");
	  var currentitem = tree.treeBoxObject.view.getItemAtIndex(tree.currentIndex);
	  var currentlabel = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowAddressesAddresstreeTreecolRealname");
	  var newlabel = prompt("Please enter the new realname for "+currentlabel,currentlabel);

	  if (newlabel != "" && newlabel != null)
	  {
	    var currentcell = document.getElementById(currentitem.getAttribute("id") + "-column1");
        currentcell.setAttribute("label",newlabel);
        var wurst = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowAddressesAddresstreeTreecolDbid");
	    var honk = parseInt(wurst);
        try
        {
          query = "UPDATE mailaddress SET realname='" + newlabel + "' WHERE (id=" + honk + ")";
          var result = connection.executeQuery(query);
        }
        catch(ex)
        {
        }
        evmInitializeAddressbooktree();
  	  }
  	}
    catch(ex)
    {
      // alert("EVM Error in function evmChangeRealnameOfMailaddress: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmDeleteAddressFromMailaddressTable()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // if mailaddress is used in none of the saved mails anymore, it can be
  // deleted if the user wants to delete it
  function evmDeleteAddressFromMailaddressTable()
  {
    try
    {
      var tree = document.getElementById("evmEVMWindowAddressesAddresstree");
	  var currentitem = tree.treeBoxObject.view.getItemAtIndex(tree.currentIndex);
	  var deleteKandidatIndex = document.getElementById("evmEVMWindowAddressesAddresstree").treeBoxObject.selection.currentIndex;
	  var parentelement = currentitem.parentNode;
	  var currentdbid = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowAddressesAddresstreeTreecolDbid");
	  var currentlabel = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowAddressesAddresstreeTreecolRealname");
	  var wurst = parseInt(currentdbid);
	  var query = "select mailaddressid from header_mailaddress where (mailaddressid=" + wurst + ")";
      try
      {
        result = connection.executeQuery(query);
      }
      catch(ex)
      {
      }
      if(evmIsEntryAvailableInDB(result))
      {
        alert("The mailaddress of " + currentlabel + " cannot be deleted because there are mails in the EVM associated with it!");
      }
      else
      {
	    var query = "select sender from header where (sender=" + wurst + ")";
        try
        {
          result = connection.executeQuery(query);
        }
        catch(ex)
        {
        }
        if(evmIsEntryAvailableInDB(result))
        {
          alert("The mailaddress of " + currentlabel + " cannot be deleted because there are mails in the EVM associated with it!");
        }
        else
	    {
          if (confirm("Do you really want to PERMANENTLY delete the mailaddress of " + currentlabel + "!?")==true)
          {
            query = "delete from mailaddress where (id =" + wurst + ")";
            try
            {
              result = connection.executeQuery(query);
            }
            catch(ex)
            {
            }
            parentelement.removeChild(currentitem);
            try
		    {
	          document.getElementById("evmEVMWindowAddressesAddresstree").treeBoxObject.selection.select(deleteKandidatIndex);
	          evmActivateAddressButtons();
		    }
		    catch(ex) { alert("x: " + ex); }
          }
        }
      }
    }
    catch(ex)
    {
      // alert("EVM Error in function evmDeleteAddressFromMailaddressTable: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmCheckNocategoryMails()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // when user closes the EVM window, s/he will be informed if there are mails
  // in the DB which do not have a category yet
  function evmCheckNocategoryMails()
  {
    var tmpcid = -1232006;
    try
    {
	  query = "select categoryid, msgid from header_category where (categoryid =" + tmpcid + ")";
      result = connection.executeQuery(query);
    }
    catch(ex) { }
    try
    {
      if(evmIsEntryAvailableInDB(result))
      {
        alert("There are mails which do not have a Category yet. The mails (which you can all see in the Mailview Tabpanel folder evmHasNoCategory) will be remembered for the next time you open the EVM window. If you do not want one, more or any of these mails to be saved in the category you are going to choose next, please remove it from the folder!");
      }
	}
    catch(ex)
    {
      alert("EVM Error in function evmCheckNocategoryMails: " + ex);
    }
    //if(gHasMailsWithNoCategory == true) alert("There are mails which do not have a Category yet. The mails (which you can all see in the Mailview Tabpanel folder evmHasNoCategory) will be remembered for the next time you open the EVM window. If you do not want one, more or any of these mails to be saved in the category you are going to choose next, please remove it from the folder!");
  }


  // *************************************************************************
  // function:		evmActivateAddressButtons()
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // activates the rename and the delete button in case an address is selected
  function evmActivateAddressButtons()
  {
	var tree = document.getElementById("evmEVMWindowAddressesAddresstree");
	if (tree.treeBoxObject.selection.count == 0)
	{
      document.getElementById("evmEVMWindowAddressesButtonChange").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowAddressesButtonDelete").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowAddressesButtonChangePopupsetMenuitemChange").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowAddressesButtonChangePopupsetMenuitemDelete").setAttribute('disabled',true);
	  return;
	}
    document.getElementById("evmEVMWindowAddressesButtonChange").setAttribute('disabled',false);
    document.getElementById("evmEVMWindowAddressesButtonDelete").setAttribute('disabled',false);
    document.getElementById("evmEVMWindowAddressesButtonChangePopupsetMenuitemChange").setAttribute('disabled',false);
    document.getElementById("evmEVMWindowAddressesButtonChangePopupsetMenuitemDelete").setAttribute('disabled',false);
  }


  // *************************************************************************
  // function:		evmOnCategorytabpaneselected()
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // if a category is selected, the buttons are activated for copying it to the
  // chosen-category-tree on the right
  function evmOnCategorytabpaneselected()
  {
	try
	{
	  gCategorytabboxLeftPaneActive = true;
	  var tree = document.getElementById("evmEVMWindowCategoryFolderpaneboxCategorytree");
	  if (tree.treeBoxObject.selection.count == 0)
	  {
        document.getElementById("evmEVMWindowCategoryButtonSubcategory").setAttribute('disabled',true);
        document.getElementById("evmEVMWindowCategoryButtonRenamecategory").setAttribute('disabled',true);
        document.getElementById("evmEVMWindowCategoryButtonDeletecategory").setAttribute('disabled',true);
        document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemSelect").setAttribute('disabled',true);
	  }
	  else
	  {
        document.getElementById("evmEVMWindowCategoryButtonSubcategory").setAttribute('disabled',false);
        document.getElementById("evmEVMWindowCategoryButtonRenamecategory").setAttribute('disabled',false);
        document.getElementById("evmEVMWindowCategoryButtonDeletecategory").setAttribute('disabled',false);
        document.getElementById("evmEVMWindowCategoryButtonOut").setAttribute('disabled',true);
	    if(gHasMailsWithNoCategory == true)
	    	{
	    		document.getElementById("evmEVMWindowCategoryButtonIn").setAttribute('disabled',false);
	    		document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemSelect").setAttribute('disabled',false);
	    	}
	    var tree = document.getElementById("evmEVMWindowCategoryFolderpaneboxCategorytree");
      	var cellcontent = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowCategoryFolderpaneboxCategorytreeTreecolCategory");
      	var cellcontentid = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowCategoryFolderpaneboxCategorytreeTreecolDbid");
      	try
      	{
		  var what = cellcontentid.split("EVMWindowCategoryFolderpaneboxCategorytree");
      	  if(ChosenCategories[what[1]] == cellcontent)
      	  {
      	  	document.getElementById("evmEVMWindowCategoryButtonIn").setAttribute('disabled',true);
      	  	document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemSelect").setAttribute('disabled',true);
      	  }
      	}
      	catch(ex)
      	{
      	}
      }
    }
    catch(ex)
    {
      alert("EVM Error in function evmOnCategorytabpaneselected: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmOnChosenCategorytabpaneselected()
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // kind of an event handler for the chosen-category-tree on the right
  function evmOnChosenCategorytabpaneselected()
  {
      gCategorytabboxLeftPaneActive = false;
      document.getElementById("evmEVMWindowCategoryButtonSubcategory").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonRenamecategory").setAttribute('disabled',true);
      document.getElementById("evmEVMWindowCategoryButtonDeletecategory").setAttribute('disabled',true);
	  var tree = document.getElementById("evmEVMWindowCategoryFolderpaneboxChosencategorytree");
	  if (tree.treeBoxObject.selection.count != 0)
	  {
        document.getElementById("evmEVMWindowCategoryButtonOut").setAttribute('disabled',false);
        document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemUnselect").setAttribute('disabled',false);
      }
      else
	    document.getElementById("evmEVMWindowTabpanelCategoryPopupsetMenuitemUnselect").setAttribute('disabled',true);
  }


  // *************************************************************************
  // function:		evmRenameCurrentCategory()
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // calls the user interface for renaming a category in case one is selected
  function evmRenameCurrentCategory(treename,columnname)
  {
	try
	{
	  //if(gCategorytabboxLeftPaneActive == false) return;
	  var tree = document.getElementById(treename);
	  if (tree.treeBoxObject.selection.count == 0) return;
	  evmRenameCurrent(treename,columnname);
	}
    catch(ex)
    {
      alert("EVM Error in function evmRenameCurrentCategory: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmDeleteCurrentCategory()
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // deletes a category
  // this function also moves mails to the trash
  function evmDeleteCurrentCategory(treename)
  {
	//if(gCategorytabboxLeftPaneActive == false) return;
	var tree = document.getElementById(treename);
	if (tree.treeBoxObject.selection.count == 0) return;
	evmDeleteCurrent(treename);
  }


  // *************************************************************************
  // function:		evmCreateNewSubcategory()
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // creates a new subcategory
  function evmCreateNewSubcategory(treename)
  {
	try
	{
	  if(gCategorytabboxLeftPaneActive == false) return;
	  var tree = document.getElementById(treename);
	  if (tree.treeBoxObject.selection.count == 0) return;
	  evmUserCreateCategory(treename, true);
	}
    catch(ex)
    {
      alert("EVM Error in function evmCreateNewSubcategory: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmCreateNewCategory()
  // status:		not needed anymore
  // author:		Kai Henning
  // *************************************************************************
  // switches to the third tabpanel in case user wants to create a new top-
  // or subcategory
  function evmCreateNewCategory()
  {
	if (confirm("Please create new Categories in the second tabbox! Just press 'OK' and we will take you there!")==true)
	  evmChangePaneTo(2);
  }


  // *************************************************************************
  // function:		evmEmptyCache()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // sets all paramters back (when we leave the panel or close the window
  function evmEmptyCache()
  {
    try
    {
      for(var i = 1; i <= bodycount + 10; i++) evmXDeleteFile("chrome://evm/content/evmtmp" + i + ".html",true);
      bodycache = {};
      bodycount = 0;
      sizecount = 0;
      visitcount = {};
      onetoobigexception = false;
    }
    catch(ex)
    {
      alert("EVM Error in function evmEmptyCache: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmLeastVisits(actualBody)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // finds the messageID of the mail whose body was most seldom needed; when
  // we want to add a new body, it is not visited yet, of course, so we have
  // to specify which body is the current: actualBody
  function evmLeastVisits(actualBody)
  {
    try
    {
	  var min = 0;
	  var foundelement = "";
	  for(e in visitcount)
	  {
        if((visitcount[e] < min || min == 0) && (bodycache[e] != actualBody))
        {
          min = visitcount[e];
          foundelement = e;
        }
      }
      return foundelement;
    }
    catch(ex)
    {
      alert("EVM Error in function evmLeastVisits: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmRemoveMostUnimportantBodyEntries(wegdamit)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // all entries in the paramters of the item we want to remove are deleted;
  // we have to copy objects' contents for that
  function evmRemoveMostUnimportantBodyEntries(wegdamit)
  {
    try
    {
	  var newbodycache = {};
	  var newvisitcount = {};
	  for(e in bodycache)
	  {
	    if(e != wegdamit)
	    {
	      newbodycache[e] = bodycache[e];
	      newvisitcount[e] = visitcount[e];
        }
      }
      bodycache = {};
      visitcount = {};
      for(e in newbodycache)
      {
        bodycache[e] = newbodycache[e];
	    visitcount[e] = newvisitcount[e];
      }
    }
    catch(ex)
    {
      alert("EVM Error in function evmRemoveMostUnimportantBodyEntries: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmDeleteUnimportantBodiesExceptActual(actualBodyFilename,actualBodySize)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // calls the function above and does the deleting
  function evmDeleteUnimportantBodiesExceptActual(actualBodyFilename,actualBodySize)
  {
    try
    {
	  var mostUnimportantBodyElement = evmLeastVisits(actualBodyFilename);
	  var mostUnimportantBodyFilename = bodycache[mostUnimportantBodyElement];
	  if(bodycache[mostUnimportantBodyElement])
	  {
	    evmXDeleteFile("chrome://evm/content/" + mostUnimportantBodyFilename,true);
	    evmRemoveMostUnimportantBodyEntries(mostUnimportantBodyElement);
	    sizecount = sizecount - actualBodySize;
	  }
	  if(actualBodySize >= sizemax) onetoobigexception = true;
	  else onetoobigexception = false;
    }
    catch(ex)
    {
      alert("EVM Error in function evmDeleteUnimportantBodiesExceptActual: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmRemoveAllCachedBodiesExceptCurrent(current)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // in case we have one single mail bigger than our cache, we have to remove
  // all other elements
  function evmRemoveAllCachedBodiesExceptCurrent(current)
  {
    try
    {
	  var oneEntryOnly = false;
	  while(oneEntryOnly == false)
	  {
        var i = 0;
        for(e in bodycache) i++;
        if(i == 1 || i == 0) return;
        evmRemoveMostUnimportantBodyEntries(evmLeastVisits(current));
      }
    }
    catch(ex)
    {
      alert("EVM Error in function evmRemoveAllCachedBodiesExceptCurrent: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmElementcount(treename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // returns number of items in tree
  function evmElementcount(treename)
  {
	var index = 0;
	var tree = document.getElementById(treename);
	try
	{
	  while (tree.treeBoxObject.view.getItemAtIndex(index)!=null) index++;
	}
	catch (e)
	{
	  return index;
	}
  }


  // *************************************************************************
  // function:		evmLoadBody(diff)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // adds the mail body to the message pane and writes it to the cache
  function evmLoadBody(diff)
  {
	try
	{
// does not work!? :-/
if(document.getElementById("evmEVMWindowMailviewMessagepaneBrowser").getAttribute("collapsed") == true) return;
// *********************************************************************************************************
	  var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
	  evmWriteHeaderData ();
	  if (tree.treeBoxObject.selection.count == 0 || tree.treeBoxObject.selection.count > 1)
	  {
	  	document.getElementById("evmEVMWindowMailviewMessagepaneBrowser").setAttribute('src','');

	  	return;
	  }
	  if((tree.currentIndex == 0 && diff == -1) || (evmElementcount("evmEVMWindowMailviewThreadpaneMailtree") - 1 == tree.currentIndex && diff == 1)) diff = 0;
	  var cellcontent = tree.treeBoxObject.view.getCellText(tree.currentIndex+diff,"evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid");
	  if(cellcontent in bodycache)
	  {
	    visitcount[cellcontent]++;
	    try
	    {
	      document.getElementById("evmEVMWindowMailviewMessagepaneBrowser").setAttribute('src',bodycache[cellcontent]);
	    }
	    catch(ex)
	    {
	      var mailbody = evmGetReparsedBody(cellcontent);
	      try
	      {
	        bodycount++;
	        bodycache[cellcontent] = "evmtmp" + bodycount + ".html";
	        visitcount[cellcontent] = 0;
	        currentbodiessize = evmXWriteFile("chrome://evm/content/" + bodycache[cellcontent],mailbody);
	        sizecount = sizecount + currentbodiessize;
	        document.getElementById("evmEVMWindowMailviewMessagepaneBrowser").setAttribute('src',bodycache[cellcontent]);
	      }
    	  catch(ex)
    	  {
      	    alert("EVM Error in function evmLoadBody: " + ex);
    	  }
	    }
	  }
	  else
	  {
	    var mailbody = evmGetReparsedBody(cellcontent);
	    try
	    {
	      bodycount++;
	      bodycache[cellcontent] = "evmtmp" + bodycount + ".html";
	      visitcount[cellcontent] = 0;
	      currentbodiessize = evmXWriteFile("chrome://evm/content/" + bodycache[cellcontent],mailbody);
	      sizecount = sizecount + currentbodiessize;
	      document.getElementById("evmEVMWindowMailviewMessagepaneBrowser").setAttribute('src',bodycache[cellcontent]);
	    }
        catch(ex)
        {
          alert("EVM Error in function evmLoadBody: " + ex);
        }
	  }
	  while(sizecount >= sizemax && onetoobigexception == false)
	  {
	    evmDeleteUnimportantBodiesExceptActual(bodycache[cellcontent],currentbodiessize);
	  }
	  if(onetoobigexception == true)
	  {
	    evmRemoveAllCachedBodiesExceptCurrent(bodycache[cellcontent]);
	    sizecount = currentbodiessize;
	    onetoobigexception = false;
	  }
	  evmRemoveToofastclicksRests();
	}
    catch(ex)
    {
      alert("EVM Error in function evmLoadBody: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmRemoveToofastclicksRests()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // when the user clicks through his mailbox too fast, the cache size is not
  // checked (javascript-mistake), so this functions checks now and then whether
  // there are mails left which should have been deleted some time ago already
  function evmRemoveToofastclicksRests()
  {
	try
	{
	  for(var i = 1; i <= bodycount; i++)
	  {
	    var existenzberechtigung = false;
	    for(e in bodycache)
	    {
	      if(bodycache[e] == "evmtmp" + i + ".html") existenzberechtigung = true;
	    }
	    if(existenzberechtigung == false) evmXDeleteFile("chrome://evm/content/evmtmp" + i + ".html",true);
	  }
	}
    catch(ex)
    {
      alert("EVM Error in function evmRemoveToofastclickRests: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmInitializePreferences()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // initializes the tabpanel for the preferences where the user can specify
  // how large the cache size should be
  function evmInitializePreferences()
  {
	try
	{
	  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  try
	  {
	    var evmcachesize = pref.getIntPref("evm.cachesizeKB");
	  }
	  catch(ex)
	  {
	    var evmcachesize = 10;
	  }
	  document.getElementById("evmEVMWindowTabpanelPreferencesTextboxCachesize").setAttribute('value',evmcachesize);
	}
    catch(ex)
    {
      alert("EVM Error in function evmInitializePreferences: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmCheckAndUpdateEVMCacheSize()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // when the user clicks 'update' in the tabpanel Preferences, it is checked
  // whether the value is a number larger than 0. In this case, it is updated
  // to the preferences
  function evmCheckAndUpdateEVMCacheSize()
  {
	try
	{
	  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  var eingegeben = document.getElementById("evmEVMWindowTabpanelPreferencesTextboxCachesize").value;
	  try
	  {
	    var wurst = parseInt(eingegeben);
	    if(evmIsInteger(wurst) && wurst > 0)
	    {
	      pref.setIntPref("evm.cachesizeKB",wurst);
	      sizemax = wurst;
	      alert("Cache Size successfully updated to " + wurst + " KB.\n\nPlease note: the size of temporary files might grow larger than this value in some situations, but this will be corrected as soon as possible!");
	    }
	    else
	    {
		  try
		  {
		    var evmcachesize = pref.getIntPref("evm.cachesizeKB");
		  }
		  catch(ex)
		  {
		    var evmcachesize = 10;
		  }
		  document.getElementById("evmEVMWindowTabpanelPreferencesTextboxCachesize").setAttribute('value',evmcachesize);
	      alert("Invalid Size of Cache!");
	    }
	  }
	  catch(ex)
	  {
	    try
	    {
	      var evmcachesize = pref.getIntPref("evm.cachesizeKB");
	    }
	    catch(ex)
	    {
	      var evmcachesize = 10;
	    }
	    document.getElementById("evmEVMWindowTabpanelPreferencesTextboxCachesize").setAttribute('value',evmcachesize);
	    alert("Invalid Size of Cache!");
	  }
	}
    catch(ex)
    {
      alert("EVM Error in function evmCheckAndUpdateEVMCacheSize: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmGetAttachmentMailDir()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // if no userpath is yet given, we ask the user to enter a valid path; when
  // a path is entered, we immediatly try to write a temporary file to it to
  // see whether we have access etc. In case everything is fine, we let EVM
  // start :-)
  function evmGetAttachmentMailDir()
  {
    try
	{
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	  include(jslib_io);
	  include(jslib_fileutils);
	  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  try
	  {
	    userpath = pref.getCharPref("evm.amailpath");
	    return userpath;
	  }
	  catch(ex)
	  {
  		var rootpath = pref.getCharPref("mail.root.none");
  		if(rootpath.indexOf("/") > 0) pref.setCharPref("evm.pathseparator","/");
  		else
  		{
    	  if(rootpath.indexOf("\\") > 0) pref.setCharPref("evm.pathseparator","\\");
    	  else pref.setCharPref("evm.pathseparator","evmPathSeparatorError_contactSupport");
  		}
	    chromepath = evmReturnChromePath("dummy");
	    chromepath = evmSplitter(chromepath,"/",evmPathSep());
	    chromepath = chromepath.split("dumm");
	    userpath = prompt('When saving mails with attachment, we need a directory where we can store this data permanently. Please enter a directory which exsists where no errors will occur concerning file access etc.\n\nWarning: Only if you enter a correct directory, this program will start. The directory cannot be changed anymore, and you are not asked again to enter a directory unless you uninstall Mozilla with all of its components as we store the directory information in Mozilla\'s own preferences.',chromepath[0]);
		if(userpath == null || userpath == "null") return "evmAttachmentMailError";
	    userpath = evmSplitter(userpath,"/",evmPathSep());
	    userpath = userpath.split(evmPathSep());
	    var newuserpath = "";
	    for(var i = 0; i < userpath.length; i++) if(userpath[i] != "" && userpath[i] != " ") newuserpath = newuserpath + userpath[i] + evmPathSep();
	    try
	    {
	  	  var file = new File(newuserpath + "test.evm");
	  	  file.create();
	  	  file.open("w");
	      file.write("remove this file!");
		  if (file.exists() == true)
		  {
		    file.remove(newuserpath + "test.evm");
		    pref.setCharPref("evm.amailpath",newuserpath);
		    return newuserpath;
		  }
		  else
		  {
	  	    alert("No valid directory!");
	  		return "evmAttachmentMailError";
		  }
	    }
	    catch(ex)
	    {
	      alert("No valid directory!");
	      return "evmAttachmentMailError";
	    }
	  }
	  return "evmAttachmentMailError";
	}
    catch(ex)
    {
      alert("EVM Error in function evmGetAttachmentMailDir: " + ex);
    }
  }


  // *************************************************************************
  // function:		evmThreadPaneKeyPress(event)
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // event-handler for keys being pressed
  function evmThreadPaneKeyPress(event)
  {
    var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
    var cellcontent = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSubject");
	//alert(cellcontent + " " + event.keyCode);
    if (event.keyCode == 13) evmOpenEVMMessageInMozillaWindow(); // 13 = return
    else if (event.keyCode == 46) evmDeleteMarkedMessage(true); // 46 = delete
    else if (event.keyCode == 40) evmLoadBody(1); // 40 = down
    else if (event.keyCode == 38) evmLoadBody(-1); // 38 = up
	else
	{
	  var t = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
	  f = t.treeBoxObject.selection;
	}
  }


  // *************************************************************************
  // function:		evmEmptytrash()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // deletes all files from the trash
  function evmEmptytrash()
  {
	if(confirm("Do you really want to PERMANENTLY delete all messages in the trash folder!?") == true)
	{
	  // evmInitializeThreadpaneConcerningCategory(-7011980);
	  evmEmptyCache();
	  evmDeleteMarkedMessage(false,true);

	}
  }


  // *************************************************************************
  // function:		evmStuffInTrash()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // returns a boolean statement about whether there are mails in the trashcan
  // - without having to look into the DB! ;-)
  function evmStuffInTrash()
  {
    var tree = document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytree");
	var currentitem = tree.treeBoxObject.view.getItemAtIndex(tree.currentIndex);
	var currentlabel = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowCategoryFolderpaneboxCategorytreeTreecolTotal");
	if(parseInt(currentlabel) >= 1) return true;
	else return false;
  }


 // *************************************************************************
  // function:		evmOpenEVMMessageInMozillaWindow()
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // two possibilities:
  // we either have a mail with attachment which is stored in a physical file on
  // the harddisc: we copy the file to the local folders and open the one and only
  // mail in it
  // or we have a mail without attachment: we call the evmCreateFakeMailboxFromDBEntries(messageID)
  // to do the work then... ;-)
  function evmOpenEVMMessageInMozillaWindow()
  {
	try
	{
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
      netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      include (jslib_io);
      include(jslib_fileutils);
	  var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
	  var selectedmails = evmGetAllSelectedTreeitems("evmEVMWindowMailviewThreadpaneMailtree",false);
	  for (var EVMx=0; EVMx<selectedmails.length; EVMx++)
	  {
	    var selectedindex = tree.treeBoxObject.view.getIndexOfItem(selectedmails[EVMx]);
        var messageID = tree.treeBoxObject.view.getCellText(selectedindex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid");
        var file = new File(evmGetAttachmentMailDir() + "evmMail_" + messageID + ".evm");
        var newfilename = "evmTemp_" + messageID;
        createdFilesInLocalFolder.push(newfilename);
        if (file.exists() == false)
        {
          evmCreateFakeMailboxFromDBEntries(messageID);
        }
        else
        {
          var f = new File(evmGetMailboxpathFromServerURI("mailbox://nobody@Local%20Folders") + evmPathSep() + newfilename);
          try {if (f.exists()==true) f.remove();} catch(err) {};
          file.copy(evmGetMailboxpathFromServerURI("mailbox://nobody@Local%20Folders") + evmPathSep() + newfilename);
          // var currentFolderURI = GetSelectedFolderURI();
          // SelectFolder("mailbox://nobody@Local%20Folders");
          var tmpdialog = evmShowWaitDialogue(1,1,-200)
       	  tmpdialog.close();
          MsgOpenNewWindowForMessage("mailbox-message://nobody@Local%20Folders/" + newfilename + "#0", "mailbox://nobody@Local%20Folders/" + newfilename);
          // SelectFolder(currentFolderURI);
          file.close();
        }
      }
    }
    catch (ex)
    {
    	alert(ex)
    }
  }


  // *************************************************************************
  // function:		evmRemoveTempFileInLocalFolders()
  // status:		finished
  // author:		Kai Henning, Andr Grothues
  // *************************************************************************
  // removes the temporary mailbox we created in Mozilla's local folders for
  // displaying evm-mails in Mozilla's windows
  function evmRemoveTempFileInLocalFolders()
  {
  	try
  	{
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
      netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      include (jslib_io);
      include(jslib_fileutils);
      for (var x=0; x<createdFilesInLocalFolder.length; x++)
      {
        var file = new File(evmGetMailboxpathFromServerURI("mailbox://nobody@Local%20Folders")+ evmPathSep() + createdFilesInLocalFolder[x]);
        if (file.exists() == true) file.remove();
      }
    }
    catch(ex)
    {
    	alert(ex);
    }
  }


  // *************************************************************************
  // function:		evmCreateFakeMailboxFromDBEntries(messageID)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // from the DB, we retrieve DB info, split it up and write it into the file
  // line by line so that we create a mailbox which is readable for Mozilla
  // to be able to display the files in Mozilla windows
  function evmCreateFakeMailboxFromDBEntries(messageID)
  {
    try
    {
	  query = "select id, meta from header where msgid='" + messageID + "'";
      result = connection.executeQuery(query);
    }
    catch(ex) { }
    try
    {
      if(evmIsEntryAvailableInDB(result) == false) return;
	  var e = result.enumerate();
      e.first();
	  var header_metadata = e.getVariant(1);
	  var header_meta = [];
	  var header_meta = header_metadata.split(",,,");
	  var newfilename = "evmTemp_" + messageID;
	  var file = new File(evmGetMailboxpathFromServerURI("mailbox://nobody@Local%20Folders")+ evmPathSep() + newfilename);
	  if (file.exists()==true) file.remove();
	  file.create();
	  file.open("w");
	  file.write("From - EVM" + "\n");
	  for(var i = 0; i < header_meta.length; i++)
	  {
	    var to_be_inserted = header_meta[i].split(":::");
	    if(to_be_inserted[0].toLowerCase() != "content-type" && to_be_inserted[0].toLowerCase() != "content-transfer-encoding" && to_be_inserted[0].toLowerCase() != "messageid")
	      file.write(to_be_inserted[0] + ": " + to_be_inserted[1] + "\n");
	    else
	    {
	      if(to_be_inserted[0].toLowerCase() != "content-type") file.write("content-type: text/html; charset=us-ascii" + "\n");
	      else if(to_be_inserted[0].toLowerCase() != "content-transfer-encoding") file.write("content-transfer-encoding: 7bit" + "\n");
	    }
	  }
	  file.write("\n");
	  file.write(evmGetReparsedBody(messageID));
	  file.write("\n");
	  file.close();
	  var tmpdialog = evmShowWaitDialogue(1,1,-200)
	  tmpdialog.close();
	  MsgOpenNewWindowForMessage("mailbox-message://nobody@Local%20Folders/" + newfilename + "#0", "mailbox://nobody@Local%20Folders/" + newfilename);
	}
	catch(ex)
	{
	  // alert(ex);
	}
  }


  // *************************************************************************
  // function:		evmDeleteNotNeededAddressesFromMailaddressTable()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // all mailaddresses which are not associated with mails can be delted with
  // this... we normally always keep mailaddresses to create a kind of an
  // 'addressbook'
  function evmDeleteNotNeededAddressesFromMailaddressTable()
  {
	if(confirm("Do you really want to PERMANENTLY delete all mailaddresses no mails are associated with!?") == true)
	{
	  var query = "SELECT id, address FROM mailaddress WHERE address NOT IN (SELECT address FROM mailaddress JOIN header_mailaddress ON (id = mailaddressid)) AND address NOT IN (SELECT address FROM mailaddress JOIN header ON (sender = mailaddress.id))";
	  try
	  {
	    var r = connection.executeQuery(query);
	  }
	  catch(ex)
	  {
	  }
	  try
	  {
        if (r.rowCount > 0)
        {
		  var enumerator = r.enumerate();
          enumerator.first();
          for(var i = 1; i <= r.rowCount; i++)
          {
            try { connection.executeQuery("DELETE FROM mailaddress WHERE (address ='" + enumerator.getVariant(1) + "')"); } catch(ex) { }
			if(i < r.rowCount) enumerator.next();
          }
		  evmInitializeAddressbooktree();
        }
      }
      catch(ex)
      {
      }
	}
  }


  // *************************************************************************
  // function:		evmCategoryKeyPress(event)
  // function:		evmAddressKeyPress(event)
  // function:		evmMailviewCatKeyPress(event)
  // status:		finished
  // author:		Kai Henning / Oliver Hakim
  // *************************************************************************
  // even-handlers for delete-buttons in different situations
  function evmCategoryKeyPress(event)
  {
	if (event.keyCode == 46) evmDeleteCurrentCategory('evmEVMWindowCategoryFolderpaneboxCategorytree'); // 46 = delete
  }
  function evmAddressKeyPress(event)
  {
	if (event.keyCode == 46) evmDeleteAddressFromMailaddressTable();
  }
  function evmMailviewCatKeyPress(event)
  {
	if (event.keyCode == 46) evmDeleteCurrentCategory('evmEVMWindowMailviewFolderpaneboxCategorytree');
  }


  // *************************************************************************
  // function:		evmPathSep()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // returns \ or / or -if no entry available- makes the entry itself
  function evmPathSep()
  {
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    try
    {
      var x = pref.getCharPref("evm.pathseparator");
    }
    catch(ex)
    {
      try
      {
  		var rootpath = pref.getCharPref("mail.root.none");
  		if(rootpath.indexOf("/") > 0) pref.setCharPref("evm.pathseparator","/");
  		else
  		{
    	  if(rootpath.indexOf("\\") > 0) pref.setCharPref("evm.pathseparator","\\");
    	  else pref.setCharPref("evm.pathseparator","evmPathSeparatorError_contactSupport");
  		}
  		var x = pref.getCharPref("evm.pathseparator");
  	  }
  	  catch(ex)
  	  {
  	  }
    }
    return x;
  }

// **************************************************************************
// ********************** END of EVM-XUL Functions **************************
// **************************************************************************