CREATE TABLE header
(
  id BIGINT NOT NULL,
  msgid VARCHAR NOT NULL,
  sender BIGINT NOT NULL,
  subject VARCHAR,
  ref VARCHAR,
  tstamp VARCHAR,
  date DATE NOT NULL,
  time TIME NOT NULL,
  priority INTEGER,
  meta VARCHAR,
  PRIMARY KEY (msgid)
);

CREATE TABLE body
(
  id BIGINT NOT NULL,
  bodytext VARCHAR,
  msgID VARCHAR NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE attachment
(
  id BIGINT NOT NULL,
  name VARCHAR,
  type VARCHAR NOT NULL,
  location text NOT NULL,
  msgid VARCHAR NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE mailaddress
(
  id BIGINT NOT NULL,
  address VARCHAR NOT NULL,
  realname VARCHAR,
  PRIMARY KEY (id)
);

CREATE TABLE category
(
  id BIGINT NOT NULL,
  name VARCHAR NOT NULL,
  childOf BIGINT NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE account
(
  id BIGINT NOT NULL,
  address VARCHAR NOT NULL,
  realname VARCHAR,
  PRIMARY KEY (id)
);

CREATE TABLE header_mailaddress
(
  msgID VARCHAR NOT NULL,
  mailaddressID BIGINT NOT NULL,
  mailadrType VARCHAR NOT NULL,
  PRIMARY KEY (msgID,mailaddressID,mailadrType)
);

CREATE TABLE header_category
(
  msgID VARCHAR NOT NULL,
  categoryID BIGINT NOT NULL
);

CREATE TABLE search
(
  id BIGINT NOT NULL,
  name VARCHAR NOT NULL,
  childOf BIGINT NOT NULL,
  searchstring VARCHAR,
  PRIMARY KEY (id)
);